#include <windows.h>		// Header File For Windows
#include <stdio.h>			// Header File For Standard Input/Output
#include <conio.h>			// Header File For Console Input/Output
#include <gl\gl.h>			// Header File For The OpenGL32 Library
#include <gl\glu.h>			// Header File For The GLu32 Library
#include <gl\glaux.h>		// Header File For The Glaux Library
#include <gl\glut.h>		// Header File For The Glut Library


#pragma comment (lib, "opengl32")
#pragma comment (lib, "glu32")
#pragma comment (lib, "glaux")
#pragma comment (lib, "glut32")


#include "..\Headers\texture.h"
#include "..\Headers\glBasic.h"
#include "..\Headers\glDraw.h"
#include "..\Headers\keyboard.h"

bool	active=TRUE;		// Window Active Flag Set To TRUE By Default
int windowX, windowY;		// Ower screens dimensions
bool useNormals = FALSE;	// Use normals or not

bool internalError = FALSE;

// Motion blur implementation
GLuint		motionBlur_Texture;				// The Texture
int motionBlur_Texture_X,					// X Coordonate
	motionBlur_Texture_Y,					// Y Coordonate
	motionBlur_Texture_channels,			// Number of Chanels
	motionBlur_Texture_type;				// The Type
float	motionBlur_Red_intensity = 1.0f,	// Red intensity
		motionBlur_Green_intensity = 1.0f,	// Green intensity
		motionBlur_Blue_intensity = 1.0f,	// Blue intensity
		motionBlur_Alpha_intensity = 0.7f;	// Alpha intensity
bool	motionBlur_FirstRenderTexture = true;	// Do we render the scene first or not?


GLuint		conic_texture;	// I wonder what could this be too? :)
bool		renderConicWireframe = false;	// use wireframe?
bool		DrawAlternateScene = false;		// draw alternate scene?
bool		useMotionBlur = true;			// do we use motion blur?


void Display() {
	DrawGLScene();
	glutSwapBuffers();
	glutPostRedisplay();
}

int main(int argc, char **argv)
{
	printf("Usable keys :\n");
	printf("\t't' - switches motion blur rendering technique\n");
	printf("\t'a\\r\\g\\b' - sets current cursor on the specified color coordonate\n");
	printf("\t'x\\y\\z' - selects the second scene rotation incremets\n");
	printf("\t'+\\-' - increments\\decreases the current selected item\n");
	printf("\t'u' - sets\\unsets the use of normals\n");
	printf("\t'w' - sets\\unsets the use of wireframe\n");
	printf("\t'm' - sets\\unsets the use of motion blur\n");
	printf("\t's' - switches scenes\n");
	printf("\tESC - quits the application\n");

	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH);
	glutInitWindowSize(640, 480);
	glutCreateWindow("Full Scene Motion Blur");
	InitGL();
	glutDisplayFunc(Display);
	glutReshapeFunc(ReSizeGLScene);
	glutKeyboardFunc(CheckKeys);

	if(internalError) {
		printf("Internal error, the program can not continue!\nPress any key to continue...");
		getch();
		return 0;
	}

	glutMainLoop();
	return 0;
}