#include "..\Headers\core.h"
#include "..\Headers\glBasic.h"
#include "..\Headers\texture.h"
#include "..\Headers\motionblur.h"
#include "..\Headers\tunnel.h"

int InitGL(GLvoid)										// All Setup For OpenGL Goes Here
{
	if (!LoadGLTextures())								// Jump To Texture Loading Routine ( NEW )
	{
		internalError = TRUE;
		return FALSE;									// If Texture Didn't Load Return FALSE
	}
	InitConic();

	glEnable(GL_TEXTURE_2D);							// Enable Texture Mapping ( NEW )

	glShadeModel(GL_SMOOTH);							// Enable Smooth Shading

	glClearColor(0.0f, 0.0f, 0.0f, 0.5f);				// Black Background
	glClearDepth(1000.0f);									// Depth Buffer Setup

	glEnable(GL_DEPTH_TEST);							// Enables Depth Testing
	glDepthFunc(GL_LEQUAL);								// The Type Of Depth Testing To Do
	
	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);	// Really Nice Perspective Calculations

	return TRUE;										// Initialization Went OK
}

// Here we load all ower textures
int LoadGLTextures()									// Load Bitmaps And Convert To Textures
{
	int Status = TRUE;

	if(!LoadTexture(conic_texture ,"Data/tunnel.bmp")) {
		printf("Unable to open \"Data/tunnel.bmp\"\n");
		Status = FALSE;
	}
	if(!CreateMotionBlurTexture(Texture_MeQuality, Texture_Interpolation)) {	// - for best performance on old graphic card
	//if(!CreateMotionBlurTexture(Texture_HiQuality, Texture_Interpolation)) {	// - for best quality
		printf("Unable to create the motion blur texture!\n");
		Status = FALSE;
	}

	return Status;
}



// The window resize "hook"
GLvoid ReSizeGLScene(GLsizei width, GLsizei height)		// Resize And Initialize The GL Window
{
	windowX = width;
	windowY = height;

	if (height==0)										// Prevent A Divide By Zero By
	{
		height=1;										// Making Height Equal One
	}

	glViewport(0,0,windowX,windowY);						// Reset The Current Viewport

	glMatrixMode(GL_PROJECTION);						// Select The Projection Matrix
	glLoadIdentity();									// Reset The Projection Matrix

	// Calculate The Aspect Ratio Of The Window
	gluPerspective(45.0f,(GLfloat)width/(GLfloat)height,0.1f,100.0f);

	glMatrixMode(GL_MODELVIEW);							// Select The Modelview Matrix
	glLoadIdentity();									// Reset The Modelview Matrix
}




