#include "..\Headers\core.h"
#include "..\Headers\glBasic.h"
#include "..\Headers\texture.h"
#include "..\Headers\motionblur.h"
#include "..\Headers\glDraw.h"
#include "..\Headers\tunnel.h"


#include <math.h>
float incRotX = (float)1.2, incRotY=(float)1,incRotZ=(float)2.3;

// Do all the main drawing ideea here
int DrawGLScene(GLvoid)									// Here's Where We Do All The Drawing
{
	if(!DrawAlternateScene) {
		ApplyEcuationToConic();
		
		if(useMotionBlur) {
			RenderToMotionBlurTexture(motionBlur_FirstRenderTexture ,DrawConic);
			ShowMotionBlurTexture();
		}
		else {
			// clear the viewport
			glClearColor(0.0,0.0,0.0,0.0);
			glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);	// Clear The Screen And The Depth Buffer
			glLoadIdentity();
	
			DrawConic();
		}
	}
	else {
		if(useMotionBlur) {
			RenderToMotionBlurTexture(motionBlur_FirstRenderTexture , drawFooScene);
			ShowMotionBlurTexture();
		}
		else {
			// clear the viewport
			glClearColor(0.0,0.0,0.0,0.0);
			glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);	// Clear The Screen And The Depth Buffer
			glLoadIdentity();

			drawFooScene();
		}
	}
		
	return TRUE;										// Keep Going
}

// Draw a scene
int drawFooScene() {
	// Do all drawing here
	// NOTE IF USED WITH MOTION BLUR
	//		- if used with motion blur viewport 
	//				is (0,0, motionBlur_Texture_X, motionBlur_Texture_Y)
	//		- DO NOT CLEAR THE SCREEN 

	static float roateteDegX = 0, roateteDegY = 0 , roateteDegZ = 0, red = 0;
	static bool inc_red = true;
	
	roateteDegX+= incRotX;
	roateteDegY+= incRotY;
	roateteDegZ+= incRotZ;
	
	/*
	if(!inc_red) red += -0.01;
	else red += 0.01;
	if(red >= 1.0f || red <= 0.0f)
		inc_red = !inc_red;
	*/

	gluLookAt(0.0f, 0.0f, 6.0f,	0.0f, 0.0f, 0.0f,	0.0f, 1.0f, 0.0f);

	if(renderConicWireframe)
		glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);


	glPushMatrix();
		glBindTexture(GL_TEXTURE_2D, conic_texture);

		glRotatef(roateteDegX, roateteDegX, 0, 0);
		glRotatef(roateteDegY, 0, roateteDegY, 0);
		glRotatef(roateteDegZ, 0, 0, roateteDegZ);
		//glTranslatef(-2,0,0);
		
		glBegin(GL_QUADS);
			
			glColor3f( 1.0, 1.0, 1.0);
			// Front Face
			glTexCoord2f(0.0f, 0.0f); glVertex3f(-1.0f, -1.0f,  1.0f);	// Bottom Left Of The Texture and Quad
			glTexCoord2f(1.0f, 0.0f); glVertex3f( 1.0f, -1.0f,  1.0f);	// Bottom Right Of The Texture and Quad
			glTexCoord2f(1.0f, 1.0f); glVertex3f( 1.0f,  1.0f,  1.0f);	// Top Right Of The Texture and Quad
			glTexCoord2f(0.0f, 1.0f); glVertex3f(-1.0f,  1.0f,  1.0f);	// Top Left Of The Texture and Quad
			// Back Face
			glTexCoord2f(1.0f, 0.0f); glVertex3f(-1.0f, -1.0f, -1.0f);	// Bottom Right Of The Texture and Quad
			glTexCoord2f(1.0f, 1.0f); glVertex3f(-1.0f,  1.0f, -1.0f);	// Top Right Of The Texture and Quad
			glTexCoord2f(0.0f, 1.0f); glVertex3f( 1.0f,  1.0f, -1.0f);	// Top Left Of The Texture and Quad
			glTexCoord2f(0.0f, 0.0f); glVertex3f( 1.0f, -1.0f, -1.0f);	// Bottom Left Of The Texture and Quad
			// Top Face
			glTexCoord2f(0.0f, 1.0f); glVertex3f(-1.0f,  1.0f, -1.0f);	// Top Left Of The Texture and Quad
			glTexCoord2f(0.0f, 0.0f); glVertex3f(-1.0f,  1.0f,  1.0f);	// Bottom Left Of The Texture and Quad
			glTexCoord2f(1.0f, 0.0f); glVertex3f( 1.0f,  1.0f,  1.0f);	// Bottom Right Of The Texture and Quad
			glTexCoord2f(1.0f, 1.0f); glVertex3f( 1.0f,  1.0f, -1.0f);	// Top Right Of The Texture and Quad
			// Bottom Face
			glTexCoord2f(1.0f, 1.0f); glVertex3f(-1.0f, -1.0f, -1.0f);	// Top Right Of The Texture and Quad
			glTexCoord2f(0.0f, 1.0f); glVertex3f( 1.0f, -1.0f, -1.0f);	// Top Left Of The Texture and Quad
			glTexCoord2f(0.0f, 0.0f); glVertex3f( 1.0f, -1.0f,  1.0f);	// Bottom Left Of The Texture and Quad
			glTexCoord2f(1.0f, 0.0f); glVertex3f(-1.0f, -1.0f,  1.0f);	// Bottom Right Of The Texture and Quad
			// Right face
			glTexCoord2f(1.0f, 0.0f); glVertex3f( 1.0f, -1.0f, -1.0f);	// Bottom Right Of The Texture and Quad
			glTexCoord2f(1.0f, 1.0f); glVertex3f( 1.0f,  1.0f, -1.0f);	// Top Right Of The Texture and Quad
			glTexCoord2f(0.0f, 1.0f); glVertex3f( 1.0f,  1.0f,  1.0f);	// Top Left Of The Texture and Quad
			glTexCoord2f(0.0f, 0.0f); glVertex3f( 1.0f, -1.0f,  1.0f);	// Bottom Left Of The Texture and Quad
			// Left Face
			glTexCoord2f(0.0f, 0.0f); glVertex3f(-1.0f, -1.0f, -1.0f);	// Bottom Left Of The Texture and Quad
			glTexCoord2f(1.0f, 0.0f); glVertex3f(-1.0f, -1.0f,  1.0f);	// Bottom Right Of The Texture and Quad
			glTexCoord2f(1.0f, 1.0f); glVertex3f(-1.0f,  1.0f,  1.0f);	// Top Right Of The Texture and Quad
			glTexCoord2f(0.0f, 1.0f); glVertex3f(-1.0f,  1.0f, -1.0f);	// Top Left Of The Texture and Quad
		glEnd();

	glPopMatrix();

	if(renderConicWireframe) 
		glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);

	return TRUE;
}